/*
 * This file is part of the nivo project.
 *
 * Copyright 2016-present, Raphaël Benitte.
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */
import _ from 'lodash-es';

var recursiveFlattener = function recursiveFlattener(stack, node, identityProperty, parentId) {
    if (node.children) {
        node.children.forEach(function (child) {
            recursiveFlattener(stack, child, identityProperty, node[identityProperty]);
        });
    } else {
        stack.push(_.assign({}, node, { parentId: parentId }));
    }
};

export var flatten = function flatten(root, identityProperty) {
    var nodes = [];

    recursiveFlattener(nodes, root, identityProperty);

    return { children: nodes };
};