function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
 * This file is part of the nivo project.
 *
 * Copyright 2016-present, Raphaël Benitte.
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */
import React, { Component } from 'react';
import { findDOMNode } from 'react-dom';
import _ from 'lodash-es';
import { bubblePropTypes, bubbleDefaultProps } from './BubbleProps';
import Nivo from '../../../Nivo';
import BubbleD3Svg from '../../../lib/charts/bubble/BubbleD3Svg';
import decoratorsFromReactChildren from '../../../lib/decoratorsFromReactChildren';

var BubbleD3 = function (_Component) {
    _inherits(BubbleD3, _Component);

    function BubbleD3() {
        _classCallCheck(this, BubbleD3);

        return _possibleConstructorReturn(this, _Component.apply(this, arguments));
    }

    BubbleD3.prototype.renderChart = function renderChart(props) {
        this.bubble.decorate(decoratorsFromReactChildren(props.children, 'decorateBubble'));
        this.bubble.draw(_.assign({}, props, {
            margin: _.assign({}, Nivo.defaults.margin, props.margin)
        }));
    };

    BubbleD3.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps) {
        this.renderChart(nextProps);

        return false;
    };

    BubbleD3.prototype.componentDidMount = function componentDidMount() {
        this.bubble = BubbleD3Svg(findDOMNode(this.refs.svg));
        this.renderChart(this.props);
    };

    BubbleD3.prototype.render = function render() {
        return React.createElement('svg', { ref: 'svg', className: 'nivo_bubble' });
    };

    return BubbleD3;
}(Component);

BubbleD3.propTypes = _.omit(bubblePropTypes, ['children', 'namespace', 'motionStiffness', 'motionDamping']);

BubbleD3.defaultProps = _.omit(bubbleDefaultProps, ['namespace', 'motionStiffness', 'motionDamping']);

export default BubbleD3;