var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from 'react';
import PropTypes from 'prop-types';
import pure from 'recompose/pure';

var tooltipStyle = {
    display: 'flex',
    alignItems: 'center'
};

var chipStyle = {
    display: 'block',
    width: '16px',
    height: '16px',
    marginRight: '9px',
    borderRadius: '2px'
};

var textStyle = {
    whiteSpace: 'pre'
};

var PieSliceTooltip = function PieSliceTooltip(_ref) {
    var id = _ref.id,
        value = _ref.value,
        color = _ref.color;
    return React.createElement(
        'div',
        { style: tooltipStyle },
        React.createElement('span', { style: _extends({}, chipStyle, { background: color }) }),
        React.createElement(
            'span',
            { style: textStyle },
            id,
            ': ',
            React.createElement(
                'strong',
                null,
                value
            )
        )
    );
};

PieSliceTooltip.propTypes = {
    id: PropTypes.oneOfType([PropTypes.string, PropTypes.number]).isRequired,
    value: PropTypes.number.isRequired,
    color: PropTypes.string.isRequired
};

export default pure(PieSliceTooltip);