var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
 * This file is part of the nivo project.
 *
 * Copyright 2016-present, Raphaël Benitte.
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import RadialStack from './RadialStack';
import Dimensions from 'react-dimensions';

var ResponsiveRadialStack = function (_Component) {
    _inherits(ResponsiveRadialStack, _Component);

    function ResponsiveRadialStack() {
        _classCallCheck(this, ResponsiveRadialStack);

        return _possibleConstructorReturn(this, _Component.apply(this, arguments));
    }

    ResponsiveRadialStack.prototype.render = function render() {
        var _props = this.props,
            containerWidth = _props.containerWidth,
            containerHeight = _props.containerHeight;


        return React.createElement(RadialStack, _extends({ width: containerWidth, height: containerHeight }, this.props));
    };

    return ResponsiveRadialStack;
}(Component);

ResponsiveRadialStack.displayName = 'ResponsiveRadialStack';

export default Dimensions()(ResponsiveRadialStack);