import React from 'react';
import PropTypes from 'prop-types';

var DiagonalsPattern = function DiagonalsPattern(_ref) {
    var id = _ref.id,
        size = _ref.size,
        background = _ref.background,
        foreground = _ref.foreground,
        strokeWidth = _ref.strokeWidth;
    return React.createElement(
        'pattern',
        { id: id, width: size, height: size, patternUnits: 'userSpaceOnUse' },
        React.createElement('rect', { width: size, height: size, fill: background }),
        React.createElement('line', { x1: 0, x2: size, y1: 0, y2: 0, stroke: foreground, strokeWidth: strokeWidth })
    );
};

DiagonalsPattern.propTypes = {
    id: PropTypes.string.isRequired,
    background: PropTypes.string.isRequired,
    foreground: PropTypes.string.isRequired,
    size: PropTypes.number.isRequired,
    strokeWidth: PropTypes.number.isRequired
};

DiagonalsPattern.defaultProps = {
    background: 'none',
    size: 10,
    strokeWidth: 2
};

export default DiagonalsPattern;