import React from 'react';
import PropTypes from 'prop-types';

var DotsPattern = function DotsPattern(_ref) {
    var id = _ref.id,
        background = _ref.background,
        foreground = _ref.foreground,
        size = _ref.size,
        dotSize = _ref.dotSize;
    return React.createElement(
        'pattern',
        { id: id, width: size, height: size, patternUnits: 'userSpaceOnUse' },
        React.createElement('rect', { width: size, height: size, fill: background }),
        React.createElement('rect', { x: 0, y: 0, width: dotSize, height: dotSize, fill: foreground })
    );
};

DotsPattern.propTypes = {
    id: PropTypes.string.isRequired,
    background: PropTypes.string.isRequired,
    foreground: PropTypes.string.isRequired,
    size: PropTypes.number.isRequired,
    dotSize: PropTypes.number.isRequired
};

DotsPattern.defaultProps = {
    background: 'none',
    size: 8,
    dotSize: 2
};

export default DotsPattern;