var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

/*
 * This file is part of the nivo project.
 *
 * Copyright 2016-present, Raphaël Benitte.
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */
import React from 'react';
import PropTypes from 'prop-types';
import pure from 'recompose/pure';

var tableStyle = {
    width: '100%',
    borderCollapse: 'collapse'
};

var TableTooltip = function TableTooltip(_ref) {
    var rows = _ref.rows,
        theme = _ref.theme;

    if (!rows.length) return null;

    return React.createElement(
        'table',
        { style: _extends({}, tableStyle, theme.tooltip.table) },
        React.createElement(
            'tbody',
            null,
            rows.map(function (row, i) {
                return React.createElement(
                    'tr',
                    { key: i },
                    row.map(function (column, j) {
                        return React.createElement(
                            'td',
                            { key: j, style: theme.tooltip.tableCell },
                            column
                        );
                    })
                );
            })
        )
    );
};

TableTooltip.propTypes = {
    rows: PropTypes.arrayOf(PropTypes.arrayOf(PropTypes.node)).isRequired,
    theme: PropTypes.object.isRequired
};

TableTooltip.defaultProps = {};

export default pure(TableTooltip);