/*
 * This file is part of the nivo project.
 *
 * Copyright 2016-present, Raphaël Benitte.
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */
import withProps from 'recompose/withProps';
import { curveFromProp } from '../props';

/**
 * This HOC transform d3 curve interpolation identifier
 * to its corresponding interpolator.
 */
export default (function () {
  var srcKey = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'curve';
  var destKey = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'curveInterpolator';
  return withProps(function (props) {
    var _ref;

    return _ref = {}, _ref[destKey] = curveFromProp(props[srcKey]), _ref;
  });
});