'use strict';

exports.__esModule = true;
exports.flatten = undefined;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var recursiveFlattener = function recursiveFlattener(stack, node, identityProperty, parentId) {
    if (node.children) {
        node.children.forEach(function (child) {
            recursiveFlattener(stack, child, identityProperty, node[identityProperty]);
        });
    } else {
        stack.push(_lodash2.default.assign({}, node, { parentId: parentId }));
    }
}; /*
    * This file is part of the nivo project.
    *
    * Copyright 2016-present, Raphaël Benitte.
    *
    * For the full copyright and license information, please view the LICENSE
    * file that was distributed with this source code.
    */
var flatten = exports.flatten = function flatten(root, identityProperty) {
    var nodes = [];

    recursiveFlattener(nodes, root, identityProperty);

    return { children: nodes };
};