'use strict';

exports.__esModule = true;
exports.defaultTheme = undefined;

var _d3Scale = require('d3-scale');

var _d3ScaleChromatic = require('d3-scale-chromatic');

var _colorUtils = require('./lib/colorUtils');

var defaults = {
    transitionDuration: 600,
    transitionEasing: 'cubic-out',
    motionStiffness: 120,
    motionDamping: 10,
    colorRange: (0, _d3Scale.scaleOrdinal)(_d3ScaleChromatic.schemeSet3),
    margin: {
        top: 0,
        right: 0,
        bottom: 0,
        left: 0
    }
}; /*
    * This file is part of the nivo project.
    *
    * Copyright 2016-present, Raphaël Benitte.
    *
    * For the full copyright and license information, please view the LICENSE
    * file that was distributed with this source code.
    */
var defaultTheme = exports.defaultTheme = {
    axis: {
        textColor: '#000',
        fontSize: '11px',
        tickColor: '#000',
        legendColor: '#000',
        legendFontSize: '11px'
    },
    grid: {
        stroke: '#ddd',
        strokeWidth: 1,
        strokeDasharray: ''
    },
    markers: {
        textColor: '#000',
        fontSize: '11px'
    }
};

exports.default = {
    defaults: defaults,
    colors: {
        nivoCategoricalColors: _colorUtils.nivoCategoricalColors
    }
};