'use strict';

exports.__esModule = true;
exports.bubbleDefaultProps = exports.bubblePropTypes = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /*
                                                                                                                                                                                                                                                                   * This file is part of the nivo project.
                                                                                                                                                                                                                                                                   *
                                                                                                                                                                                                                                                                   * Copyright 2016-present, Raphaël Benitte.
                                                                                                                                                                                                                                                                   *
                                                                                                                                                                                                                                                                   * For the full copyright and license information, please view the LICENSE
                                                                                                                                                                                                                                                                   * file that was distributed with this source code.
                                                                                                                                                                                                                                                                   */


var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Nivo = require('../../../Nivo');

var _Nivo2 = _interopRequireDefault(_Nivo);

var _props = require('../../../props');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Bubble components propTypes.
 *
 * @type {object}
 */
var bubblePropTypes = exports.bubblePropTypes = _extends({
  root: _propTypes2.default.object.isRequired,

  // dimensions
  width: _propTypes2.default.number.isRequired,
  height: _propTypes2.default.number.isRequired,
  margin: _props.marginPropType,

  leavesOnly: _propTypes2.default.bool.isRequired,
  onBubbleClick: _propTypes2.default.func.isRequired,
  identity: _propTypes2.default.string.isRequired,
  value: _propTypes2.default.string.isRequired,
  padding: _propTypes2.default.number.isRequired,

  // theming
  colors: _propTypes2.default.any.isRequired,
  colorBy: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func]).isRequired,

  // placeholders
  namespace: _propTypes2.default.oneOf(['html', 'svg']),
  children: _propTypes2.default.func.isRequired,

  // border
  borderWidth: _propTypes2.default.number.isRequired,
  borderColor: _propTypes2.default.any.isRequired,

  // labels
  enableLabel: _propTypes2.default.bool.isRequired,
  label: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func]).isRequired,
  labelFormat: _propTypes2.default.string,
  labelTextColor: _propTypes2.default.any.isRequired,
  labelTextDY: _propTypes2.default.number.isRequired,
  labelSkipRadius: _propTypes2.default.number.isRequired

}, _props.motionPropTypes, {
  transitionDuration: _propTypes2.default.number.isRequired, // d3 transitions
  transitionEasing: _propTypes2.default.string.isRequired, // d3 transitions

  // interactivity
  isInteractive: _propTypes2.default.bool.isRequired

  /**
   * Bubble components defaultProps.
   *
   * @type {object}
   */
});var bubbleDefaultProps = exports.bubbleDefaultProps = {
  // dimensions
  margin: _Nivo2.default.defaults.margin,

  leavesOnly: false,
  onBubbleClick: function onBubbleClick() {},
  identity: 'id',
  value: 'value',
  padding: 1,

  // theming
  colors: 'nivo',
  colorBy: 'depth',

  // placeholders
  namespace: 'html',

  // border
  borderWidth: 0,
  borderColor: 'inherit',

  // labels
  enableLabel: true,
  label: 'id',
  labelTextColor: 'inherit:darker(1)',
  labelTextDY: 5,
  labelSkipRadius: 0,

  // transitions
  animate: true,
  motionStiffness: _Nivo2.default.defaults.motionStiffness, // react-motion
  motionDamping: _Nivo2.default.defaults.motionDamping, // react-motion
  transitionDuration: _Nivo2.default.defaults.transitionDuration, // d3 transitions
  transitionEasing: _Nivo2.default.defaults.transitionEasing, // d3 transitions

  // interactivity
  isInteractive: true
};