'use strict';

exports.__esModule = true;
exports.treeMapDefaultProps = exports.treeMapPropTypes = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /*
                                                                                                                                                                                                                                                                   * This file is part of the nivo project.
                                                                                                                                                                                                                                                                   *
                                                                                                                                                                                                                                                                   * Copyright 2016-present, Raphaël Benitte.
                                                                                                                                                                                                                                                                   *
                                                                                                                                                                                                                                                                   * For the full copyright and license information, please view the LICENSE
                                                                                                                                                                                                                                                                   * file that was distributed with this source code.
                                                                                                                                                                                                                                                                   */

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Nivo = require('../../../Nivo');

var _Nivo2 = _interopRequireDefault(_Nivo);

var _props = require('../../../props');

var _TreeMapD = require('../../../lib/charts/treemap/TreeMapD3');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * TreeMap components propTypes.
 *
 * @type {object}
 */
var treeMapPropTypes = exports.treeMapPropTypes = _extends({
  root: _propTypes2.default.object.isRequired, // data

  // dimensions
  width: _propTypes2.default.number.isRequired, // for non responsive components
  height: _propTypes2.default.number.isRequired, // for non responsive components
  margin: _props.marginPropType,

  leavesOnly: _propTypes2.default.bool.isRequired,
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func]).isRequired,
  identity: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func]).isRequired,
  tile: _propTypes2.default.oneOf(Object.keys(_TreeMapD.tilingMethods)),

  innerPadding: _propTypes2.default.number.isRequired,
  outerPadding: _propTypes2.default.number.isRequired,

  // labels
  enableLabels: _propTypes2.default.bool.isRequired,
  orientLabels: _propTypes2.default.bool.isRequired,
  label: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func]).isRequired,
  labelFormat: _propTypes2.default.string,
  labelSkipSize: _propTypes2.default.number.isRequired,

  // theming
  colors: _propTypes2.default.any.isRequired,
  colorBy: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func]).isRequired,

  borderWidth: _propTypes2.default.number.isRequired,
  borderColor: _propTypes2.default.any.isRequired

}, _props.motionPropTypes, {
  transitionDuration: _propTypes2.default.number.isRequired, // d3 transitions
  transitionEasing: _propTypes2.default.string.isRequired, // d3 transitions

  // placeholders
  namespace: _propTypes2.default.oneOf(['html', 'svg']).isRequired,
  children: _propTypes2.default.func.isRequired

  /**
   * TreeMap components defaultProps.
   *
   * @type {object}
   */
});var treeMapDefaultProps = exports.treeMapDefaultProps = {
  leavesOnly: false,
  tile: 'squarify',
  value: 'value',
  identity: 'name',

  // labels
  enableLabels: true,
  orientLabels: true,
  label: 'id',
  labelSkipSize: 0,
  labelTextColor: 'inherit:darker(1)',

  margin: _Nivo2.default.defaults.margin,
  innerPadding: 0,
  outerPadding: 0,

  borderWidth: 0,
  borderColor: 'inherit',

  // motion
  animate: true,
  transitionDuration: _Nivo2.default.defaults.transitionDuration,
  transitionEasing: _Nivo2.default.defaults.transitionEasing,
  motionStiffness: 120,
  motionDamping: 10,

  colors: 'nivo',
  colorBy: 'depth'
};