'use strict';

exports.__esModule = true;
exports.MarkersItemDefaultProps = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _pure = require('recompose/pure');

var _pure2 = _interopRequireDefault(_pure);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MarkersItem = function MarkersItem(_ref) {
    var x = _ref.x,
        y = _ref.y,
        size = _ref.size,
        color = _ref.color,
        borderWidth = _ref.borderWidth,
        borderColor = _ref.borderColor,
        label = _ref.label,
        labelTextAnchor = _ref.labelTextAnchor,
        labelYOffset = _ref.labelYOffset,
        theme = _ref.theme;

    return _react2.default.createElement(
        'g',
        { transform: 'translate(' + x + ', ' + y + ')' },
        _react2.default.createElement('circle', {
            r: size / 2,
            fill: color,
            stroke: borderColor,
            strokeWidth: borderWidth,
            style: { pointerEvents: 'none' }
        }),
        label && _react2.default.createElement(
            'text',
            {
                textAnchor: labelTextAnchor,
                y: labelYOffset,
                style: {
                    fontSize: theme.markers.fontSize,
                    fill: theme.markers.textColor,
                    pointerEvents: 'none'
                }
            },
            label
        )
    );
}; /*
    * This file is part of the nivo project.
    *
    * Copyright 2016-present, Raphaël Benitte.
    *
    * For the full copyright and license information, please view the LICENSE
    * file that was distributed with this source code.
    */


MarkersItem.propTypes = {
    x: _propTypes2.default.number.isRequired,
    y: _propTypes2.default.number.isRequired,
    size: _propTypes2.default.number.isRequired,
    color: _propTypes2.default.string.isRequired,
    borderWidth: _propTypes2.default.number.isRequired,
    borderColor: _propTypes2.default.string.isRequired,
    label: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
    labelTextAnchor: _propTypes2.default.oneOf(['start', 'middle', 'end']),
    labelYOffset: _propTypes2.default.number.isRequired,
    theme: _propTypes2.default.shape({
        markers: _propTypes2.default.shape({
            textColor: _propTypes2.default.string.isRequired,
            fontSize: _propTypes2.default.string.isRequired
        }).isRequired
    }).isRequired
};

var MarkersItemDefaultProps = exports.MarkersItemDefaultProps = {
    labelTextAnchor: 'middle',
    labelYOffset: -12
};

MarkersItem.defaultProps = MarkersItemDefaultProps;

exports.default = (0, _pure2.default)(MarkersItem);