'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _pure = require('recompose/pure');

var _pure2 = _interopRequireDefault(_pure);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var tableStyle = {
    fontSize: '14px',
    width: '100%',
    borderCollapse: 'collapse'
}; /*
    * This file is part of the nivo project.
    *
    * Copyright 2016-present, Raphaël Benitte.
    *
    * For the full copyright and license information, please view the LICENSE
    * file that was distributed with this source code.
    */


var cellStyle = {
    padding: '3px 5px'
};

var TableTooltip = function TableTooltip(_ref) {
    var rows = _ref.rows;

    if (!rows.length) return null;

    return _react2.default.createElement(
        'table',
        { style: tableStyle },
        _react2.default.createElement(
            'tbody',
            null,
            rows.map(function (row, i) {
                return _react2.default.createElement(
                    'tr',
                    { key: i },
                    row.map(function (column, j) {
                        return _react2.default.createElement(
                            'td',
                            { key: j, style: cellStyle },
                            column
                        );
                    })
                );
            })
        )
    );
};

TableTooltip.propTypes = {
    rows: _propTypes2.default.arrayOf(_propTypes2.default.arrayOf(_propTypes2.default.node)).isRequired
};

TableTooltip.defaultProps = {};

exports.default = (0, _pure2.default)(TableTooltip);