'use strict';

exports.__esModule = true;
exports.curvePropType = exports.curvePropKeys = exports.curvePropMapping = undefined;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _d3Shape = require('d3-shape');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * This file is part of the nivo project.
 *
 * Copyright 2016-present, Raphaël Benitte.
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

var curvePropMapping = exports.curvePropMapping = {
    basis: _d3Shape.curveBasis,
    basisClosed: _d3Shape.curveBasisClosed,
    basisOpen: _d3Shape.curveBasisOpen,
    bundle: _d3Shape.curveBundle,
    cardinal: _d3Shape.curveCardinal,
    cardinalClosed: _d3Shape.curveCardinalClosed,
    cardinalOpen: _d3Shape.curveCardinalOpen,
    catmullRom: _d3Shape.curveCatmullRom,
    catmullRomClosed: _d3Shape.curveCatmullRomClosed,
    catmullRomOpen: _d3Shape.curveCatmullRomOpen,
    linear: _d3Shape.curveLinear,
    linearClosed: _d3Shape.curveLinearClosed,
    monotoneX: _d3Shape.curveMonotoneX,
    monotoneY: _d3Shape.curveMonotoneY,
    natural: _d3Shape.curveNatural,
    step: _d3Shape.curveStep,
    stepAfter: _d3Shape.curveStepAfter,
    stepBefore: _d3Shape.curveStepBefore
};

var curvePropKeys = exports.curvePropKeys = Object.keys(curvePropMapping);

var curvePropType = exports.curvePropType = _propTypes2.default.oneOf(curvePropKeys);